// Code generated by go-swagger; DO NOT EDIT.

// (c) 2012-2020 by Taxnexus, Inc.
// All rights reserved worldwide.
// Proprietary product; unlicensed use is not allowed

package company_services

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"code.tnxs.net/vernonkeenan/lib/api/research/research_models"
)

// CreateCompanyServiceReader is a Reader for the CreateCompanyService structure.
type CreateCompanyServiceReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *CreateCompanyServiceReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 200:
		result := NewCreateCompanyServiceOK()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewCreateCompanyServiceUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewCreateCompanyServiceForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 409:
		result := NewCreateCompanyServiceConflict()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 422:
		result := NewCreateCompanyServiceUnprocessableEntity()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewCreateCompanyServiceInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	default:
		return nil, runtime.NewAPIError("response status code does not match any response statuses defined for this endpoint in the swagger spec", response, response.Code())
	}
}

// NewCreateCompanyServiceOK creates a CreateCompanyServiceOK with default headers values
func NewCreateCompanyServiceOK() *CreateCompanyServiceOK {
	return &CreateCompanyServiceOK{}
}

/*
CreateCompanyServiceOK describes a response with status code 200, with default header values.

Response with CompanyService objects
*/
type CreateCompanyServiceOK struct {
	Payload *research_models.CompanyServiceResponse
}

// IsSuccess returns true when this create company service o k response has a 2xx status code
func (o *CreateCompanyServiceOK) IsSuccess() bool {
	return true
}

// IsRedirect returns true when this create company service o k response has a 3xx status code
func (o *CreateCompanyServiceOK) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create company service o k response has a 4xx status code
func (o *CreateCompanyServiceOK) IsClientError() bool {
	return false
}

// IsServerError returns true when this create company service o k response has a 5xx status code
func (o *CreateCompanyServiceOK) IsServerError() bool {
	return false
}

// IsCode returns true when this create company service o k response a status code equal to that given
func (o *CreateCompanyServiceOK) IsCode(code int) bool {
	return code == 200
}

// Code gets the status code for the create company service o k response
func (o *CreateCompanyServiceOK) Code() int {
	return 200
}

func (o *CreateCompanyServiceOK) Error() string {
	return fmt.Sprintf("[POST /companyservices][%d] createCompanyServiceOK  %+v", 200, o.Payload)
}

func (o *CreateCompanyServiceOK) String() string {
	return fmt.Sprintf("[POST /companyservices][%d] createCompanyServiceOK  %+v", 200, o.Payload)
}

func (o *CreateCompanyServiceOK) GetPayload() *research_models.CompanyServiceResponse {
	return o.Payload
}

func (o *CreateCompanyServiceOK) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(research_models.CompanyServiceResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateCompanyServiceUnauthorized creates a CreateCompanyServiceUnauthorized with default headers values
func NewCreateCompanyServiceUnauthorized() *CreateCompanyServiceUnauthorized {
	return &CreateCompanyServiceUnauthorized{}
}

/*
CreateCompanyServiceUnauthorized describes a response with status code 401, with default header values.

Access unauthorized, invalid API-KEY was used
*/
type CreateCompanyServiceUnauthorized struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

// IsSuccess returns true when this create company service unauthorized response has a 2xx status code
func (o *CreateCompanyServiceUnauthorized) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create company service unauthorized response has a 3xx status code
func (o *CreateCompanyServiceUnauthorized) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create company service unauthorized response has a 4xx status code
func (o *CreateCompanyServiceUnauthorized) IsClientError() bool {
	return true
}

// IsServerError returns true when this create company service unauthorized response has a 5xx status code
func (o *CreateCompanyServiceUnauthorized) IsServerError() bool {
	return false
}

// IsCode returns true when this create company service unauthorized response a status code equal to that given
func (o *CreateCompanyServiceUnauthorized) IsCode(code int) bool {
	return code == 401
}

// Code gets the status code for the create company service unauthorized response
func (o *CreateCompanyServiceUnauthorized) Code() int {
	return 401
}

func (o *CreateCompanyServiceUnauthorized) Error() string {
	return fmt.Sprintf("[POST /companyservices][%d] createCompanyServiceUnauthorized  %+v", 401, o.Payload)
}

func (o *CreateCompanyServiceUnauthorized) String() string {
	return fmt.Sprintf("[POST /companyservices][%d] createCompanyServiceUnauthorized  %+v", 401, o.Payload)
}

func (o *CreateCompanyServiceUnauthorized) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *CreateCompanyServiceUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateCompanyServiceForbidden creates a CreateCompanyServiceForbidden with default headers values
func NewCreateCompanyServiceForbidden() *CreateCompanyServiceForbidden {
	return &CreateCompanyServiceForbidden{}
}

/*
CreateCompanyServiceForbidden describes a response with status code 403, with default header values.

Access forbidden, account lacks access
*/
type CreateCompanyServiceForbidden struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

// IsSuccess returns true when this create company service forbidden response has a 2xx status code
func (o *CreateCompanyServiceForbidden) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create company service forbidden response has a 3xx status code
func (o *CreateCompanyServiceForbidden) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create company service forbidden response has a 4xx status code
func (o *CreateCompanyServiceForbidden) IsClientError() bool {
	return true
}

// IsServerError returns true when this create company service forbidden response has a 5xx status code
func (o *CreateCompanyServiceForbidden) IsServerError() bool {
	return false
}

// IsCode returns true when this create company service forbidden response a status code equal to that given
func (o *CreateCompanyServiceForbidden) IsCode(code int) bool {
	return code == 403
}

// Code gets the status code for the create company service forbidden response
func (o *CreateCompanyServiceForbidden) Code() int {
	return 403
}

func (o *CreateCompanyServiceForbidden) Error() string {
	return fmt.Sprintf("[POST /companyservices][%d] createCompanyServiceForbidden  %+v", 403, o.Payload)
}

func (o *CreateCompanyServiceForbidden) String() string {
	return fmt.Sprintf("[POST /companyservices][%d] createCompanyServiceForbidden  %+v", 403, o.Payload)
}

func (o *CreateCompanyServiceForbidden) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *CreateCompanyServiceForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateCompanyServiceConflict creates a CreateCompanyServiceConflict with default headers values
func NewCreateCompanyServiceConflict() *CreateCompanyServiceConflict {
	return &CreateCompanyServiceConflict{}
}

/*
CreateCompanyServiceConflict describes a response with status code 409, with default header values.

Conflict
*/
type CreateCompanyServiceConflict struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

// IsSuccess returns true when this create company service conflict response has a 2xx status code
func (o *CreateCompanyServiceConflict) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create company service conflict response has a 3xx status code
func (o *CreateCompanyServiceConflict) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create company service conflict response has a 4xx status code
func (o *CreateCompanyServiceConflict) IsClientError() bool {
	return true
}

// IsServerError returns true when this create company service conflict response has a 5xx status code
func (o *CreateCompanyServiceConflict) IsServerError() bool {
	return false
}

// IsCode returns true when this create company service conflict response a status code equal to that given
func (o *CreateCompanyServiceConflict) IsCode(code int) bool {
	return code == 409
}

// Code gets the status code for the create company service conflict response
func (o *CreateCompanyServiceConflict) Code() int {
	return 409
}

func (o *CreateCompanyServiceConflict) Error() string {
	return fmt.Sprintf("[POST /companyservices][%d] createCompanyServiceConflict  %+v", 409, o.Payload)
}

func (o *CreateCompanyServiceConflict) String() string {
	return fmt.Sprintf("[POST /companyservices][%d] createCompanyServiceConflict  %+v", 409, o.Payload)
}

func (o *CreateCompanyServiceConflict) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *CreateCompanyServiceConflict) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateCompanyServiceUnprocessableEntity creates a CreateCompanyServiceUnprocessableEntity with default headers values
func NewCreateCompanyServiceUnprocessableEntity() *CreateCompanyServiceUnprocessableEntity {
	return &CreateCompanyServiceUnprocessableEntity{}
}

/*
CreateCompanyServiceUnprocessableEntity describes a response with status code 422, with default header values.

Unprocessable Entity, likely a bad parameter
*/
type CreateCompanyServiceUnprocessableEntity struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

// IsSuccess returns true when this create company service unprocessable entity response has a 2xx status code
func (o *CreateCompanyServiceUnprocessableEntity) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create company service unprocessable entity response has a 3xx status code
func (o *CreateCompanyServiceUnprocessableEntity) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create company service unprocessable entity response has a 4xx status code
func (o *CreateCompanyServiceUnprocessableEntity) IsClientError() bool {
	return true
}

// IsServerError returns true when this create company service unprocessable entity response has a 5xx status code
func (o *CreateCompanyServiceUnprocessableEntity) IsServerError() bool {
	return false
}

// IsCode returns true when this create company service unprocessable entity response a status code equal to that given
func (o *CreateCompanyServiceUnprocessableEntity) IsCode(code int) bool {
	return code == 422
}

// Code gets the status code for the create company service unprocessable entity response
func (o *CreateCompanyServiceUnprocessableEntity) Code() int {
	return 422
}

func (o *CreateCompanyServiceUnprocessableEntity) Error() string {
	return fmt.Sprintf("[POST /companyservices][%d] createCompanyServiceUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *CreateCompanyServiceUnprocessableEntity) String() string {
	return fmt.Sprintf("[POST /companyservices][%d] createCompanyServiceUnprocessableEntity  %+v", 422, o.Payload)
}

func (o *CreateCompanyServiceUnprocessableEntity) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *CreateCompanyServiceUnprocessableEntity) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewCreateCompanyServiceInternalServerError creates a CreateCompanyServiceInternalServerError with default headers values
func NewCreateCompanyServiceInternalServerError() *CreateCompanyServiceInternalServerError {
	return &CreateCompanyServiceInternalServerError{}
}

/*
CreateCompanyServiceInternalServerError describes a response with status code 500, with default header values.

Server Internal Error
*/
type CreateCompanyServiceInternalServerError struct {
	AccessControlAllowOrigin string

	Payload *research_models.Error
}

// IsSuccess returns true when this create company service internal server error response has a 2xx status code
func (o *CreateCompanyServiceInternalServerError) IsSuccess() bool {
	return false
}

// IsRedirect returns true when this create company service internal server error response has a 3xx status code
func (o *CreateCompanyServiceInternalServerError) IsRedirect() bool {
	return false
}

// IsClientError returns true when this create company service internal server error response has a 4xx status code
func (o *CreateCompanyServiceInternalServerError) IsClientError() bool {
	return false
}

// IsServerError returns true when this create company service internal server error response has a 5xx status code
func (o *CreateCompanyServiceInternalServerError) IsServerError() bool {
	return true
}

// IsCode returns true when this create company service internal server error response a status code equal to that given
func (o *CreateCompanyServiceInternalServerError) IsCode(code int) bool {
	return code == 500
}

// Code gets the status code for the create company service internal server error response
func (o *CreateCompanyServiceInternalServerError) Code() int {
	return 500
}

func (o *CreateCompanyServiceInternalServerError) Error() string {
	return fmt.Sprintf("[POST /companyservices][%d] createCompanyServiceInternalServerError  %+v", 500, o.Payload)
}

func (o *CreateCompanyServiceInternalServerError) String() string {
	return fmt.Sprintf("[POST /companyservices][%d] createCompanyServiceInternalServerError  %+v", 500, o.Payload)
}

func (o *CreateCompanyServiceInternalServerError) GetPayload() *research_models.Error {
	return o.Payload
}

func (o *CreateCompanyServiceInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	// hydrates response header Access-Control-Allow-Origin
	hdrAccessControlAllowOrigin := response.GetHeader("Access-Control-Allow-Origin")

	if hdrAccessControlAllowOrigin != "" {
		o.AccessControlAllowOrigin = hdrAccessControlAllowOrigin
	}

	o.Payload = new(research_models.Error)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
